close all
clear all

scelta=menu('Select an image: ','CATS','ESCHER','MRI','HAND','LENA');
switch scelta
    case 1
    x_image = imread('gatti.jpg');
    case 2
    x_image = imread('fish.jpg');
    case 3
    x_image = imread('sagittal.jpg');
    case 4
    x_image = imread('mano.jpg');
    case 5
    x_image = imread('lena256.pgm');
    otherwise
    error('ONLY BETWEEN 1 and 5!!');
end
A_d=double(x_image);
siz = size(A_d);
if length(siz)>2
    A = A_d(:,:,1);
else
    A = A_d;
end
figure
m = siz(1); n = siz(2);

%Add noise  
%rum=input('Select the noise level: ');
rum = 0.4;
%adds Gaussian white noise of mean M and variance V to the image I. 
A_n = addnoise(A,rum); 

iter=input('Number of iterations ');
 
figure(1)
subplot(2,3,1)
imshow(uint8(A));
title('Original Image'); 
subplot(2,3,2)
imshow(uint8(A_n));
title('Noisy Image');

A_cal=calore(A_n,iter);
subplot(2,3,3)
imshow(uint8(A_cal))
title('Heat Equation 2D');

K1=85;%45;
A_PM=NL_diffusion(A_n,'pm1',iter,K1);
figure(1)
subplot(2,3,4)
imshow(uint8(A_PM));
title('Perona Malik');

%% TODO
% K1=10;
%A_PM_8=diffusion(A_n,'pm_8',iter,K1);
% subplot(2,3,5)
% imshow(uint8(A_PM_8));
% title('Perona Malik (8-neighbours)');

AA=double(A_n);
A_TV=calc_tv(AA);
figure(1)
subplot(2,3,6)
imshow(uint8(A_TV));
title('Total Variation');

% Compute error in Frobenius norm 
erroreHeat = norm(A_cal - A,'fro') / norm(A,'fro')
errorePM1 = norm(A_PM - A,'fro') / norm(A,'fro')
%errorePM2 = norm(A_PM_8 - A,'fro') / norm(A,'fro')
erroreTV = norm(A_TV - A,'fro') / norm(A,'fro')

